### Function Macro

# GObject DEFINE_TYPE

since: 2.4

#### Declaration [src]

    #define G_DEFINE_TYPE (
      TN,
      t_n,
      T_P
    )

#### Description [src]

A convenience macro for type implementations, which declares a class initialization function, an instance initialization function (see `GTypeInfo` for information about these) and a static variable named `t_n_parent_class` pointing to the parent class. Furthermore, it defines a `*_get_type()` function. See G_DEFINE_TYPE_EXTENDED() for an example.

Available since: 2.4

This function is not directly available to language bindings.

#### Parameters

`TN`

  Type: `-`

  The name of the new type, in Camel case.

`t_n`

  Type: `-`

  The name of the new type, in lowercase, with words separated by `_`.

`T_P`

  Type: `-`

  The `GType` of the parent type.